<template>
   
  <div class="container mb-2">
    <div class="col-md-6 mt-4" style="margin:auto; border:2px solid black;" >
      <h2 style="text-align: center;"> SignUp Here</h2> 
      <div >
        <h4 :class="error ? 'errormessage' : 'defaultErrorMessage' " v.show="error">{{errorMesage}}</h4>
      </div>
      <form @submit.prevent="onSignUp()" style="padding:2rem;" autocomplete="off">
       
        <div class="mb-3 mt-3">
          <label class="form-label">Name:</label>
          <input type="text" class="form-control" placeholder="Enter Name"  v-model.trim="formData.name" @focus="error=false" autocomplete="off">
        </div>
        <div class="mb-3 mt-3">
          <label class="form-label">Email:</label>
          <input type="email" class="form-control" placeholder="Enter email" v-model.trim="formData.email" @focus="error=false" autocomplete="off">
        </div>
  
        <div class="mb-3">
          <label class="form-label">Phone:</label>
          <div class="form-group mt-2 d-inline-block">
              <span class="border-end country-code px-2">+91</span>
              <input type="number" class="form-control" autocomplete=off v-model="formData.phoneNumber" placeholder="Enter Phone Number" maxlength=10 @focus="error=false" />
          </div>
        </div>
        

        <div class="mb-3">
          <select class="form-select" v-model="formData.country"  @focus="error=false">
            <option value="">Select country</option>
            <option value="India">India</option>
            <option value="Russia">Russia</option>
            <option value="Israel">Israel</option>
          </select>
        </div>

        <div class='col-md-12 mb-3 row' style="padding-left:10px;">
          <div class="form-check  col-md-2" v-for="(element,index) in arr" :key="index" >
              <input class="form-check-input" type="radio"  :value="element" name="group1" v-model="formData.gender" @focus="error=false">
              <label class="form-check-label">
                {{ element }}
              </label>
          </div>
        </div>

        <div class="mb-3">
          <label class="form-label">Upload Image</label>
          <input class="form-control" type="file"  @change="handleImage" >
          <span v-show="imageError" style="color:red">*Only .png, .jpeg and .jpg type supported</span>
        </div>

        <div class="mb-3">
          <label class="form-label">Upload Resume</label>
          <input class="form-control" type="file" @change="handleResume" >
          <span v-show="resumeError" style="color:red">*Only .pdf and .doc type supported</span>
        </div>
        
        <div class="mb-3">
          <label class="form-label">Upload Multiple Files</label>
          <input class="form-control" type="file"  @change="handleMultipleImages" multiple>
        </div>

        <div class="mb-3">
          <label class="form-label">Password:</label>
          <input type="password" class="form-control" autocomplete="chrome-off" placeholder="Enter password" v-model.trim="formData.password" @focus="error=false">
        </div>

        <div class="form-check mb-3">
          <label class="form-check-label" for="flexCheckChecked">
            Open to remote work?
          </label>
          <input class="form-check-input" type="checkbox" v-model="formData.remote_work" true-value="yes" false-value="no" @focus="error=false">
        </div>

        <button type="submit" class="btn btn-primary">Submit</button>
      </form> 
      <div className="mb-3">
        <p className="mb-0  text-center">
          Already have an account??{{' '}}
          <router-link to="/login">
            Sign In
          </router-link>
        </p>
      </div>
    </div>
  </div>
</template>
<script>
import {mapState,mapActions} from 'vuex';
import {signUpFormValidations} from '../services/Validations';
import { SIGNUP_ACTION } from '../store/storeConstants';
export default{
    name: "SignupPage",
    data() {
        return {
            error:false,
            errorMesage:"",
            formData: {
              name: "",
              email: "",
              password: "",
              phoneNumber:"",
              gender:"",
              country:"",
              image:"",
              resume:"",
              remote_work:"no",
              multipleFiles:[]
            },
            imageError:false,
            resumeError:false,
            arr:['Male','Female','Other']
        };
    },
    methods: {
      ...mapActions("auth", {
        signup: SIGNUP_ACTION
      }),
      async onSignUp() {
          //check the validations
          console.log(this.formData)
          let validation = await signUpFormValidations(this.formData);
          if(validation.success){
            this.signup(this.formData).catch(err=>{
              this.error = true
              this.errorMesage = err?.response?.data?.msg ? err?.response?.data?.msg : err
            })
          }else{
            this.error = true
            this.errorMesage = validation.message
          }
          // await checkEmail(this.formData.email)
      },
      handleImage(event){
        let file = event.target.files[0]
        if (file?.type === 'image/png' || file?.type === 'image/jpeg' || file?.type === 'image/jpg') {
          this.formData.image = file
          this.imageError = false
        }else{
          this.imageError = true
        }
      },
      handleResume(event){
        let file = event.target.files[0]
        if (file?.type) {
          const extension = file.type.split("/")[1]; // "pdf"
          const regex = /^pdf$|^doc$/;
          const isValidFile = regex.test(extension);
          if(isValidFile){
            this.formData.resume = file
            this.resumeError = false
          }else{
            this.resumeError = true
          }
        }
      },
      handleMultipleImages(event){
        this.formData.multipleFiles = event.target.files
      }
    },

    computed: {
        getName() {
            return this.$store.state.auth.name;
        }, 
        ...mapState("auth", {
            user: state => state.users
        })
        
    },

    
}

</script>


<style>
.errormessage{
  font-size: 28px;
  color: red;
  margin: auto;
  text-align: center;
}
.defaultErrorMessage{
  visibility: hidden;
}
.form-group {
  border: 1px solid #ced4da;
  padding: 5px;
  border-radius: 6px;
  width: 100%;
}
.form-group:focus {
  color: #212529;
    background-color: #fff;
    border-color: #86b7fe;
    outline: 0;
    box-shadow: 0 0 0 0.25rem rgb(13 110 253 / 25%);
}
.form-group input {
  display: inline-block;
  width: auto;
  border: none;
}
.form-group input:focus {
  box-shadow: none;
}
input::-webkit-outer-spin-button,
input::-webkit-inner-spin-button {
  -webkit-appearance: none;
  margin: 0;
}
</style>
